<template>
  <div>
    <div>
      <q-banner
        v-if="!dataSet?.afiliacion && !loading"
        inline-actions
        class="text-white bg-red"
      >
        La persona no esta afiliada actualmente.
      </q-banner>

      <div class="row q-col-gutter-md">
        <div class="col-md-6 col-xs-12">
          <div class="text-titulo q-pa-xs">Datos Personales</div>
          <q-card>
            <q-list separator dense>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="numbers" />
                </q-item-section>
                <q-item-section>Documento </q-item-section>
                <q-item-section side>{{ dataSet?.documento }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="cake" />
                </q-item-section>
                <q-item-section>Edad</q-item-section>
                <q-item-section side>{{ dataSet?.edad }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="flag" />
                </q-item-section>
                <q-item-section>Nacionalidad</q-item-section>
                <q-item-section side>{{
                  dataSet?.nacionalidad
                }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="people" />
                </q-item-section>
                <q-item-section>Apellido</q-item-section>
                <q-item-section side>{{ dataSet?.apellido }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="person" />
                </q-item-section>
                <q-item-section>Nombre</q-item-section>
                <q-item-section side>{{ dataSet?.nombre }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="celebration" />
                </q-item-section>
                <q-item-section>Nacimiento</q-item-section>
                <q-item-section side>{{ dataSet?.nacimiento }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="transgender" />
                </q-item-section>
                <q-item-section>Genero</q-item-section>
                <q-item-section side>{{ dataSet?.sexo }}</q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
        <div class="col-md-6 col-xs-12">
          <div class="text-titulo q-pa-xs">Domicilio</div>

          <q-card>
            <q-list separator dense>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="home" />
                </q-item-section>
                <q-item-section>Domicilio</q-item-section>
                <q-item-section side>{{ dataSet?.domicilio }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="menu_book" />
                </q-item-section>
                <q-item-section>CP</q-item-section>
                <q-item-section side>{{
                  dataSet?.codigo_postal
                }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="location_on" />
                </q-item-section>
                <q-item-section>Localidad</q-item-section>
                <q-item-section side>{{ dataSet?.localidad }}</q-item-section>
              </q-item>

              <q-item>
                <q-item-section avatar>
                  <q-icon name="call" />
                </q-item-section>
                <q-item-section>Telefono</q-item-section>
                <q-item-section side>{{ dataSet?.telefono }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="smartphone" />
                </q-item-section>
                <q-item-section>celular</q-item-section>
                <q-item-section side>{{ dataSet?.celular }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="alternate_email" />
                </q-item-section>
                <q-item-section>Correo</q-item-section>
                <q-item-section side>{{ dataSet?.email }}</q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>

        <div class="col-md-6 col-xs-12">
          <div class="text-titulo q-pa-xs">Estudios y Oficios</div>

          <q-card>
            <q-list separator dense>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="school" />
                </q-item-section>
                <q-item-section>Estudios</q-item-section>
                <q-item-section side>{{ dataSet?.estudios }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="psychology_alt" />
                </q-item-section>
                <q-item-section>Titulo</q-item-section>
                <q-item-section side>{{ dataSet?.titulo }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="work" />
                </q-item-section>
                <q-item-section>Trabajo</q-item-section>
                <q-item-section side>{{ dataSet?.trabajo }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="translate" />
                </q-item-section>
                <q-item-section>Idioma</q-item-section>
                <q-item-section side>{{ dataSet?.idioma }}</q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>

        <div class="col-md-6 col-xs-12">
          <div class="text-titulo q-pa-xs">Datos Scouts</div>

          <q-card>
            <q-list separator dense>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="safety_divider" />
                </q-item-section>
                <q-item-section>Tipo</q-item-section>
                <q-item-section side>{{
                  dataSet?.adulto ? 'Es Adulto' : 'Es Beneficiario'
                }}</q-item-section>
              </q-item>

              <q-item>
                <q-item-section avatar>
                  <q-icon name="fas os-funcion-dirigente" />
                </q-item-section>
                <q-item-section>Categoria</q-item-section>
                <q-item-section side>{{ dataSet?.categoria }}</q-item-section>
              </q-item>

              <q-item>
                <q-item-section avatar>
                  <q-icon name="pets" />
                </q-item-section>
                <q-item-section>totem</q-item-section>
                <q-item-section side>{{ dataSet?.totem }}</q-item-section>
              </q-item>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="emoji_events" />
                </q-item-section>
                <q-item-section>1° Afiliacion</q-item-section>
                <q-item-section side>{{
                  dataSet?.fecha_1er_afiliacion
                }}</q-item-section>
              </q-item>

              <q-item>
                <q-item-section avatar>
                  <q-icon name="fas os-scout-saludo" />
                </q-item-section>
                <q-item-section>Promesa</q-item-section>
                <q-item-section side>{{
                  dataSet?.promesa == 'N' ? 'No Tiene' : 'Si Tiene'
                }}</q-item-section>
              </q-item>

              <q-item>
                <q-item-section avatar>
                  <q-icon name="fas os-saac-lis-nacional" />
                </q-item-section>
                <q-item-section>Rama</q-item-section>
                <q-item-section side>
                  <ItemRama :rama="dataSet?.rama_codigo" />
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>

        <div class="col-md-6 col-xs-12">
          <div class="text-titulo q-pa-xs">Otros Datos</div>

          <q-card>
            <q-list separator dense>
              <q-item>
                <q-item-section avatar>
                  <q-icon name="synagogue" />
                </q-item-section>
                <q-item-section>Religion</q-item-section>
                <q-item-section side>{{ dataSet?.religion }}</q-item-section>
              </q-item>

              <q-item>
                <q-item-section avatar>
                  <q-icon name="hotel_class" />
                </q-item-section>
                <q-item-section>Necesidad especial</q-item-section>
                <q-item-section side v-if="!dataSet?.necesidad_especial">
                  No tiene
                </q-item-section>
                <q-item-section side v-if="dataSet?.necesidad_especial">
                  {{ dataSet?.tipo_de_necesidad_especial }}
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>

        <div class="col-md-6 col-xs-12" v-if="dataSet?.funciones">
          <div class="text-titulo q-pa-xs">Funciones</div>
          <q-card class="q-pa-sm">
            <Funciones :funciones="dataSet.funciones" />
          </q-card>
        </div>
      </div>

      <Loading :showing="loading" />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { useRoute } from 'vue-router';
import { api } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { PersonaFullInterface } from 'src/interfaces/PersonasInterface';
import ItemRama from 'components/Util/ItemRama.vue';
import Loading from 'src/components/Loading.vue';
import Funciones from 'src/components/Personas/Funciones.vue';

export default defineComponent({
  name: 'DatosPersonales',
  components: { Loading, ItemRama, Funciones },
  setup() {
    const loading = ref(true);
    const route = useRoute();
    // En un futuro .. en vez de tomar el uuid de la url .. podria ser un componente .. por si lo tengo que reutilizar desde otro lado
    // que recibe el uuil de forma directa
    const uuid = String(
      route.params.uuid === undefined ? '' : route.params.uuid
    );

    onMounted(() => {
      getDatosPersonales();
    });

    const dataSet = ref<PersonaFullInterface>();

    function getDatosPersonales() {
      api
        .get('/api/persona/personas/' + uuid + '/full')
        .then((response: AxiosResponse) => {
          dataSet.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return { loading, uuid, dataSet };
  },
});
</script>
